package{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;

//--------------------------------------------------------------------//
// ̃NX
  public class Body implements LabeledData{

// f[^x
    public var dataLabel:int;

// 
    public var mass:Number;

/// [g̃Xg
    public var inertia:Array;

// ʒu
    public var p:Position;

// ʒu
    public var p0:Position;

// _̃Xg
    protected var pt:Array;

//--------------------------------------------------------------------//
// ̂\z
// label - f[^x
    public function Body(label:int){
      dataLabel=label;
      mass=1.0;
      inertia=new Array(3);
      for(var i:int=0;i<3;i++){
      	inertia[i]=new Vector.<Number>(3,true);
      }
      initInertia();
      p=new Position();
      p0=new Position();
    }

//--------------------------------------------------------------------//
// ̌`\_̃XgԂ
    public function vertices():Array{
      return pt;
    }

//--------------------------------------------------------------------//
// f[^xԂ
    public function label():int{
      return dataLabel;
    }

//--------------------------------------------------------------------//
// f[^xݒ肷
// label - f[^x
    public function setLabel(label:int):void{
      dataLabel=label;
    }

//--------------------------------------------------------------------//
// [g
    protected function initInertia():void{
      for(var i:int=0;i<3;i++){
      	for(var j:int=0;j<3;j++){
      	  inertia[i][j]=0.0;
      	}
      	inertia[i][i]=1.0;
      }
    }

//--------------------------------------------------------------------//
// ʁE[gݒ肷
// mass - 
// ix - x̊[g
// iy - ẙ[g
// iz - z̊[g
    public function setMass(mass:Number,ix:Number,iy:Number,
      	      	      	    iz:Number):void{
      this.mass=mass;
      initInertia();
      inertia[0][0]=ix;
      inertia[1][1]=iy;
      inertia[2][2]=iz;
    }

//--------------------------------------------------------------------//
// ʃ}gbNXԂ
    public function massMatrix():DefaultMatrix{
      var m:DefaultMatrix=new DefaultMatrix(6,6);
      m.set(0,0,mass);
      m.set(1,1,mass);
      m.set(2,2,mass);
      for(var i:int=0;i<3;i++){
      	for(var j:int=0;j<3;j++){
      	  m.set(i+3,j+3,inertia[i][j]);
      	}
      }
      return m;
    }

//--------------------------------------------------------------------//
// ʒuԂ
    public function position():Position{
      return p;
    }

//--------------------------------------------------------------------//
// ʒuݒ肷
    public function setInitPosition():void{
      p0=p.copy();
    }

//--------------------------------------------------------------------//
// ʒuԂɖ߂
    public function initPosition():void{
      p=p0.copy();
    }

//--------------------------------------------------------------------//
// ׏dxNgԂ
// f - O
// t - OgN
// p - ʒu
    public function forceVector(f:Vector3D,t:Vector3D,
      	      	      	      	p:Position):Vector.<Number>{
      var v:Vector.<Number>=Vector.<Number>([f.x,f.y,f.z,t.x,t.y,t.z]);
      var jw:Vector.<Number>=new Vector.<Number>(3,true);
      for(var i:int=0;i<3;i++){
      	jw[i]=inertia[i][0]*p.w.x+inertia[i][1]*p.w.y
      	     +inertia[i][2]*p.w.z;
      }
      jw=Position.tildev(p.w).mulVector(jw);
      for(i=0;i<3;i++){
      	v[i+3]-=jw[i];
      }
      return v;
    }
  }
}
