package{
  import figure.DefaultMatrix;

//--------------------------------------------------------------------//
// IC[p[^
  public class EulerParameters{

// p[^ p0=cos/2
    public var p0:Number;

// p[^ p1=uxsin/2
    public var p1:Number;

// p[^ p2=uysin/2
    public var p2:Number;

// p[^ p3=uzsin/2
    public var p3:Number;

//--------------------------------------------------------------------//
// IC[p[^\z
// p0 - p[^ p0=cos/2
// p1 - p[^ p1=uxsin/2
// p2 - p[^ p2=uysin/2
// p3 - p[^ p3=uzsin/2
    public function EulerParameters(p0:Number=0.0,p1:Number=0.0,
      	      	      	      	    p2:Number=0.0,p3:Number=0.0){
      set(p0,p1,p2,p3);
    }

//--------------------------------------------------------------------//
// IC[p[^ݒ肷
// p0 - p[^ p0=cos/2
// p1 - p[^ p1=uxsin/2
// p2 - p[^ p2=uysin/2
// p3 - p[^ p3=uzsin/2
    public function set(p0:Number=0.0,p1:Number=0.0,
      	      	      	p2:Number=0.0,p3:Number=0.0):void{
      this.p0=p0;
      this.p1=p1;
      this.p2=p2;
      this.p3=p3;
    }

//--------------------------------------------------------------------//
// IC[p[^ɒl
// dp0 - p0ɉl
// dp1 - p1ɉl
// dp2 - p2ɉl
// dp3 - p3ɉl
    public function add(dp0:Number,dp1:Number,
      	      	      	dp2:Number,dp3:Number):void{
      p0+=dp0;
      p1+=dp1;
      p2+=dp2;
      p3+=dp3;
    }

//--------------------------------------------------------------------//
// ]sԂ
    public function rotateMatrix():DefaultMatrix{
      var a:DefaultMatrix=new DefaultMatrix(3,3);
      var p02:Number=p0*p0;
      a.set(0,0,2.0*(p02+p1*p1)-1.0);
      a.set(0,1,2.0*(p1*p2-p0*p3));
      a.set(0,2,2.0*(p1*p3+p0*p2));
      a.set(1,0,2.0*(p1*p2+p0*p3));
      a.set(1,1,2.0*(p02+p2*p2)-1.0);
      a.set(1,2,2.0*(p2*p3-p0*p1));
      a.set(2,0,2.0*(p1*p3-p0*p2));
      a.set(2,1,2.0*(p2*p3+p0*p1));
      a.set(2,2,2.0*(p02+p3*p3)-1.0);
      return a;
    }

//--------------------------------------------------------------------//
// s E Ԃ
    public function matrixE():DefaultMatrix{
      var e:DefaultMatrix=new DefaultMatrix(3,4);
      e.set(0,0,-p1);
      e.set(0,1,p0);
      e.set(0,2,-p3);
      e.set(0,3,p2);
      e.set(1,0,-p2);
      e.set(1,1,p3);
      e.set(1,2,p0);
      e.set(1,3,-p1);
      e.set(2,0,-p3);
      e.set(2,1,-p2);
      e.set(2,2,p1);
      e.set(2,3,p0);
      return e;
    }

//--------------------------------------------------------------------//
// s L Ԃ
    public function matrixL():DefaultMatrix{
      var l:DefaultMatrix=new DefaultMatrix(3,4);
      l.set(0,0,-p1);
      l.set(0,1,p0);
      l.set(0,2,p3);
      l.set(0,3,-p2);
      l.set(1,0,-p2);
      l.set(1,1,-p3);
      l.set(1,2,p0);
      l.set(1,3,p1);
      l.set(2,0,-p3);
      l.set(2,1,p2);
      l.set(2,2,-p1);
      l.set(2,3,p0);
      return l;
    }

//--------------------------------------------------------------------//
// K
    public function normalize():void{
      var p:Number=p0*p0+p1*p1+p2*p2+p3*p3;
      if(p==0.0) return;
      p=1.0/Math.sqrt(p);
      p0*=p;
      p1*=p;
      p2*=p;
      p3*=p;
    }

//--------------------------------------------------------------------//
// IC[p[^̃Rs[Ԃ
    public function copy():EulerParameters{
      return new EulerParameters(p0,p1,p2,p3);
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "EulerParameters\t"+p0+"\t"+p1+"\t"+p2+"\t"+p3;
    }
  }
}
