package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.events.TimerEvent;
  import flash.ui.Keyboard;
  import flash.utils.Timer;
  import flash.text.TextFormat;
  import component.Button;
  import component.TextBox;

//--------------------------------------------------------------------//
// ANVǗNX
  public class MBDActionManager{

// Xe[W
    internal var stage:Stage;

// ̌n\f
    internal var view:MBDViewModel;

// }EX{^ĂƂ true
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// ^C}[
    internal var timer:Timer;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - ̌n\f
// waitTime - ^C}[Ԋuimsecj
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function MBDActionManager(sprite:Sprite,
      	      	      	      	     view:MBDViewModel,waitTime:int,
      	      	      	      	     x:int,y:int,width:int,
      	      	      	      	     textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
      timer=new Timer(waitTime);
      timer.addEventListener(TimerEvent.TIMER,run);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;
      textFormat.color=fgColor;

      var start:Button=new Button("Start",fgColor,bgColor,
      	      	      	      	  0,y,textFormat);
      var stop:Button=new Button("Stop",fgColor,bgColor,
      	      	      	      	 0,y,textFormat);
      var init:Button=new Button("Init",fgColor,bgColor,
      	      	      	      	 0,y,textFormat);
      var w:int=start.width+stop.width+init.width;
      start.x=x+width/2-w/2-TextBox.CL;
      stop.x=start.x+start.width+TextBox.CL;
      init.x=stop.x+stop.width+TextBox.CL;

      start.addEventListener(MouseEvent.CLICK,calcStart);
      stop.addEventListener(MouseEvent.CLICK,calcStop);
      init.addEventListener(MouseEvent.CLICK,calcInit);

      sprite.addChild(start);
      sprite.addChild(stop);
      sprite.addChild(init);
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	if(event.shiftKey){
      	  view.translate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else if(event.ctrlKey){
      	  view.zoom(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else{
      	  view.rotate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_0:
      	case Keyboard.NUMBER_0:
      	case Keyboard.A:
      	case Keyboard.Z:
      	  view.initView();
      	  break;
      	case Keyboard.X:
      	  view.viewX();
      	  break;
      	case Keyboard.Y:
      	  view.viewY();
      	  break;
      }
    }

//--------------------------------------------------------------------//
// vZJn
    internal function calcStart(event:Event):void{
      timer.start();
    }

//--------------------------------------------------------------------//
// vZ𒆒f
    internal function calcStop(event:Event):void{
      timer.stop();
    }

//--------------------------------------------------------------------//
// Ԃɖ߂
    internal function calcInit(event:Event):void{
      timer.reset();
      view.getModel().initPosition();
      view.draw();
    }

//--------------------------------------------------------------------//
// ^C}[s
    public function run(event:TimerEvent):void{
      view.getModel().next();
      view.draw();
    }
  }
}
