package{
  import flash.geom.Vector3D;
  import flash.events.Event;
  import flash.events.EventDispatcher;
  import body.*;
  import constraint.*;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ̌nf[^fǂݍ݃NX
  public class MultiBodyModelReader extends EventDispatcher{

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// ̌nf[^f
    internal var model:MultiBodyModel;

// e[u`f[^
    internal var data:TableData;

//--------------------------------------------------------------------//
// f[^ǂݍ
    public function readData(fileName:String,model:MultiBodyModel):void{
      this.model=model;
      data=new TableData();
      data.readData(fileName);
      data.addEventListener(TableData.LOAD_COMPLETE,onTextloaded);
    }

//--------------------------------------------------------------------//
// f[^ǂݍ
    internal function onTextloaded(event:Event):void{
      var alpha:Number=0.0;
      var beta:Number=0.0;
      var row:int=0;
      while(row<data.array.length){
      	if(data.array[row].length>0){
      	  var keyWord:String=data.array[row][0].toLowerCase();
      	  if(keyWord=="dt"){
      	    var dt:Number=Number(data.array[row][1]);
      	    model.setDt(dt);
      	  }
      	  else if(keyWord=="baumgarte"){
      	    alpha=Number(data.array[row][1]);
      	    beta=Number(data.array[row][2]);
      	  }
      	  else if(keyWord=="box"){
      	    var box:Box=readBox(data.array[row]);
      	    row++;
      	    setPosition(box,data.array[row]);
      	    model.addBody(box);
      	  }
      	  else if(keyWord=="cylinder"){
      	    var cyl:Cylinder=readCylinder(data.array[row]);
      	    row++;
      	    setPosition(cyl,data.array[row]);
      	    model.addBody(cyl);
      	  }
      	  else if(keyWord=="sphere"){
      	    var sph:Sphere=readSphere(data.array[row]);
      	    row++;
      	    setPosition(sph,data.array[row]);
      	    model.addBody(sph);
      	  }
      	  else if(keyWord=="universaljoint"){
      	    model.addConstraint(readUniversalJoint(data.array[row]));
      	  }
      	  else if(keyWord=="balljoint"){
      	    model.addConstraint(readBallJoint(data.array[row]));
      	  }
      	  else if(keyWord=="rotatejoint"){
      	    model.addConstraint(readRotateJoint(data.array[row]));
      	  }
      	  else if(keyWord=="cylinderjoint"){
      	    model.addConstraint(readCylinderJoint(data.array[row]));
      	  }
      	  else if(keyWord=="slider"){
      	    model.addConstraint(readSlider(data.array[row]));
      	  }
      	  else if(keyWord=="spring"){
      	    model.addSpring(readSpring(data.array[row]));
      	  }
      	  else if(keyWord=="gravity"){
      	    model.setGravity(new Vector3D(Number(data.array[row][1]),
      	      	      	      	      	  Number(data.array[row][2]),
      	      	      	      	      	  Number(data.array[row][3]),
      	      	      	      	      	  1.0));
      	  }
      	}
      	row++;
      }

      if((alpha>0.0) && (beta>0.0)) model.setBaumgarte(alpha,beta);
      model.init();
      dispatchEvent(new Event(TableData.LOAD_COMPLETE));
    }

//--------------------------------------------------------------------//
// pԂ
// array - f[^ǂݍޔz
    protected function readBox(array:Array):Box{
      var label:int=int(array[1]);
      var a:Number=Number(array[2]);
      var b:Number=Number(array[3]);
      var c:Number=Number(array[4]);
      var dens:Number=Number(array[5]);
      return new Box(label,a,b,c,dens);
    }

//--------------------------------------------------------------------//
// ~Ԃ
// array - f[^ǂݍޔz
    protected function readCylinder(array:Array):Cylinder{
      var label:int=int(array[1]);
      var ro:Number=Number(array[2]);
      var ri:Number=Number(array[3]);
      var l:Number=Number(array[4]);
      var dens:Number=Number(array[5]);
      return new Cylinder(label,ro,ri,l,dens);
    }

//--------------------------------------------------------------------//
// 󋅂Ԃ
// array - f[^ǂݍޔz
    protected function readSphere(array:Array):Sphere{
      var label:int=int(array[1]);
      var ro:Number=Number(array[2]);
      var ri:Number=Number(array[3]);
      var dens:Number=Number(array[4]);
      return new Sphere(label,ro,ri,dens);
    }

//--------------------------------------------------------------------//
// ̂̎pݒ肷
// b - 
// array - f[^ǂݍޔz
    protected function setPosition(b:Body,array:Array):void{
      var keyWord:String=array[0].toLowerCase();
      if(keyWord=="euler"){
      	var phy:Number=TO_RADIAN*Number(array[1]);
      	var th:Number=TO_RADIAN*Number(array[2]);
      	var psi:Number=TO_RADIAN*Number(array[3]);
      	var dphy:Number=TO_RADIAN*Number(array[4]);
      	var dth:Number=TO_RADIAN*Number(array[5]);
      	var dpsi:Number=TO_RADIAN*Number(array[6]);
      	setPos(b.position(),phy,th,psi,dphy,dth,dpsi);
      }
    }

//--------------------------------------------------------------------//
// IC[pʒuݒ肷
// p - ʒu
// phy - IC[p
// th - IC[p
// psi - IC[p
// dphy - IC[pӂ̎Ԕ
// dth - IC[pƂ̎Ԕ
// dpsi - IC[pՂ̎Ԕ
    protected function setPos(p:Position,
      	      	      	      phy:Number,th:Number,psi:Number,
      	      	      	      dphy:Number,dth:Number,dpsi:Number):void{
      var sphy:Number=Math.sin(phy);
      var cphy:Number=Math.cos(phy);
      var sth:Number=Math.sin(th);
      var cth:Number=Math.cos(th);
      var spsi:Number=Math.sin(psi);
      var cpsi:Number=Math.cos(psi);
      var p0:Number=0.5*Math.sqrt((1.0+Math.cos(phy+psi))*(1.0+cth));
      if(p0>0.0){
      	var p1:Number=0.25*sth*(cpsi+cphy)/p0;
      	var p2:Number=0.25*sth*(sphy-spsi)/p0;
      	var p3:Number=0.25*(1.0+cth)*Math.sin(phy+psi)/p0;
      	p.p.set(p0,p1,p2,p3);
      }
      else{
      	p1=Math.sqrt(0.5*(cphy*cpsi-sphy*cth*spsi+1.0));
      	if(p1>0.0){
      	  p2=-0.25*Math.sin(phy-psi)*(1.0-cth)/p1;
      	  p3=0.25*sth*(sphy+spsi)/p1;
      	  p.p.set(p0,p1,p2,p3);
      	}
      	else{
      	  p2=Math.sqrt(0.5*(-sphy*spsi+cphy*cth*cpsi+1.0));
      	  if(p2>0.0){
      	    p3=-0.25*sth*(cphy-cpsi)/p2;
      	    p.p.set(p0,p1,p2,p3);
      	  }
      	  else{
      	    p3=Math.sqrt(0.5*(cth+1.0));
      	    p.p.set(p0,p1,p2,p3);
      	  }
      	}
      }
      p.w.x=sth*spsi*dphy+cpsi*dth;
      p.w.y=sth*cpsi*dphy-spsi*dth;
      p.w.z=cth*spsi*dphy+dpsi;
    }

//--------------------------------------------------------------------//
// WCgԂ
// array - f[^ǂݍޔz
    protected function readBallJoint(array:Array):BallJoint{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var x1:Number=Number(array[3]);
      var y1:Number=Number(array[4]);
      var z1:Number=Number(array[5]);
      var x2:Number=Number(array[6]);
      var y2:Number=Number(array[7]);
      var z2:Number=Number(array[8]);
      return new BallJoint(p1,p2,new Point3D(x1,y1,z1),
      	      	      	   new Point3D(x2,y2,z2));
    }

//--------------------------------------------------------------------//
// jo[TWCgԂ
// array - f[^ǂݍޔz
    protected function readUniversalJoint(array:Array):UniversalJoint{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var x1:Number=Number(array[3]);
      var y1:Number=Number(array[4]);
      var z1:Number=Number(array[5]);
      var x2:Number=Number(array[6]);
      var y2:Number=Number(array[7]);
      var z2:Number=Number(array[8]);
      return new UniversalJoint(p1,p2,new Point3D(x1,y1,z1),
      	      	      	      	new Point3D(x2,y2,z2));
    }

//--------------------------------------------------------------------//
// ]WCgԂ
// array - f[^ǂݍޔz
    protected function readRotateJoint(array:Array):RotateJoint{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var x1:Number=Number(array[3]);
      var y1:Number=Number(array[4]);
      var z1:Number=Number(array[5]);
      var x2:Number=Number(array[6]);
      var y2:Number=Number(array[7]);
      var z2:Number=Number(array[8]);
      return new RotateJoint(p1,p2,new Point3D(x1,y1,z1),
      	      	      	     new Point3D(x2,y2,z2));
    }

//--------------------------------------------------------------------//
// ]~WCgԂ
// array - f[^ǂݍޔz
    protected function readCylinderJoint(array:Array):CylinderJoint{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var x1:Number=Number(array[3]);
      var y1:Number=Number(array[4]);
      var z1:Number=Number(array[5]);
      var x2:Number=Number(array[6]);
      var y2:Number=Number(array[7]);
      var z2:Number=Number(array[8]);
      var z0:Number=Number(array[9]);
      return new CylinderJoint(p1,p2,new Point3D(x1,y1,z1),
      	      	      	       new Point3D(x2,y2,z2),z0);
    }

//--------------------------------------------------------------------//
// ]iWCgԂ
// array - f[^ǂݍޔz
    protected function readSlider(array:Array):Slider{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var x1:Number=Number(array[3]);
      var y1:Number=Number(array[4]);
      var z1:Number=Number(array[5]);
      var x2:Number=Number(array[6]);
      var y2:Number=Number(array[7]);
      var z2:Number=Number(array[8]);
      var z0:Number=Number(array[9]);
      return new Slider(p1,p2,new Point3D(x1,y1,z1),
      	      	      	new Point3D(x2,y2,z2),z0);
    }

//--------------------------------------------------------------------//
// ΂˗vfԂ
// array - f[^ǂݍޔz
    protected function readSpring(array:Array):Spring{
      var p1:int=int(array[1]);
      var p2:int=int(array[2]);
      var k:Number=Number(array[3]);
      var l0:Number=Number(array[4]);
      var x1:Number=Number(array[5]);
      var y1:Number=Number(array[6]);
      var z1:Number=Number(array[7]);
      var x2:Number=Number(array[8]);
      var y2:Number=Number(array[9]);
      var z2:Number=Number(array[10]);
      return new Spring(p1,p2,new Point3D(x1,y1,z1),
      	      	      	new Point3D(x2,y2,z2),k,l0);
    }
  }
}
