package body{
  import figure.Point3D;

//--------------------------------------------------------------------//
// ~NX
  public class Cylinder extends Body{

// \
    public static const NTH:int=8;

// Oa
    public var ro:Number;

// a
    public var ri:Number;

// 
    public var l:Number;

// x
    public var density:Number;

//--------------------------------------------------------------------//
// ̂\z
// label f[^x
// ro - Oa
// ri - a
// l - 
// density - x
    public function Cylinder(label:int,ro:Number,ri:Number,l:Number,
      	      	      	     density:Number){
      super(label);
      this.ro=ro;
      this.ri=ri;
      this.l=l;
      this.density=density;
      mass=Math.PI*density*(ro*ro-ri*ri)*l;
      inertia[0][0]=mass*(3.0*(ro*ro+ri*ri)+l*l)/12.0;
      inertia[1][1]=inertia[0][0];
      inertia[2][2]=0.5*mass*(ro*ro+ri*ri);
      pt=new Array(4);
      for(var i:int=0;i<4;i++){
      	pt[i]=new Vector.<Point3D>(NTH,true);
      	for(var j:int=0;j<NTH;j++){
      	  pt[i][j]=new Point3D();
      	}
      }
    }

//--------------------------------------------------------------------//
// ̌`\_̃XgԂ
    public override function vertices():Array{
      var dth:Number=2.0*Math.PI/Number(NTH);
      for(var i:int=0;i<NTH;i++){
      	var th:Number=dth*Number(i);
      	var x1:Number=ri*Math.cos(th);
      	var y1:Number=ri*Math.sin(th);
      	var x2:Number=ro*Math.cos(th);
      	var y2:Number=ro*Math.sin(th);
      	pt[0][i].set(x1,y1,0.5*l);
      	pt[1][i].set(x2,y2,0.5*l);
      	pt[2][i].set(x2,y2,-0.5*l);
      	pt[3][i].set(x1,y1,-0.5*l);
      }
      p.trans(pt);
      return pt;
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "Cylinder\t"+label+"\t"+ro+"\t"+ri+"\t"+l+"\t"+density;
    }
  }
}
