package constraint{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// S̒ۃX[p[NX
  public class AbstractRigidConstraint
    extends AbstractConstraint implements RigidConstraint{

// oEKë艻p[^
    protected var alpha:Number;

// oEKë艻p[^
    protected var beta:Number;

// S}gbNX
    protected var matrix:Vector.<DefaultMatrix>;

//--------------------------------------------------------------------//
// S\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
    public function AbstractRigidConstraint(p1:int,p2:int,
      	      	      	      	      	    r1:Point3D,r2:Point3D){
      super(p1,p2,r1,r2);
      alpha=10.0;
      beta=10.0;
      matrix=new Vector.<DefaultMatrix>(2,true);
    }

//--------------------------------------------------------------------//
// oEKë艻p[^ݒ肷
// alpha - oEKë艻p[^
// beta - oEKë艻p[^
    public function setBaumgarte(alpha:Number,beta:Number):void{
      this.alpha=alpha;
      this.beta=beta;
    }

//--------------------------------------------------------------------//
// dSʒuExݒ肷
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public function setGcPosition(p1:Position,p2:Position):void{
    }

//--------------------------------------------------------------------//
// S}gbNXԂ
    public function getMatrix():Vector.<DefaultMatrix>{
      return matrix;
    }

//--------------------------------------------------------------------//
// _S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
// index - S̊Jns
    public function point(p1:Position,p2:Position,index:int):void{
      var g1:Vector.<Number>=point2(p1,r1,index,0);
      if(g1!=null){
      	vector[index]-=g1[0];
      	vector[index+1]-=g1[1];
      	vector[index+2]-=g1[2];
      }
      var g2:Vector.<Number>=point2(p2,r2,index,1);
      if(g2!=null){
      	vector[index]+=g2[0];
      	vector[index+1]+=g2[1];
      	vector[index+2]+=g2[2];
      }
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p - SΏۈʒu
// r - Sʒu
// index - S̊Jns
// mi - ̂̃CfbNX
    protected function point2(p:Position,r:Point3D,index:int,
      	      	      	      mi:int):Vector.<Number>{
      if((p==null) || (r==null)) return null;
      var rot:DefaultMatrix=p.p.rotateMatrix();
      var rtl:DefaultMatrix=Position.tildep(r);
      var cth:DefaultMatrix=mul(-1.0,mul2(rot,rtl));
      var cf:Number=Number(2*mi-1);
      for(var i:int=0;i<3;i++){
      	matrix[mi].set(index+i,i,cf);
      	for(var j:int=0;j<3;j++){
      	  matrix[mi].set(index+i,j+3,cf*cth.get(i,j));
      	}
      }
      var w:Vector.<Number>=Position.vectorToVector(p.w);
      var gam:Vector.<Number>=mulvn(mul3(rot,tilde(w),rtl),w);
      var v1:Vector.<Number>=addv2(Position.vectorToVector(p.v),
      	      	      	      	   mulvn(cth,w));
      var v2:Vector.<Number>=p.vector(r);
      for(i=0;i<3;i++){
      	gam[i]-=2.0*alpha*v1[i]+beta*beta*v2[i];
      }
      return gam;
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
// s1 - SΏە̂P̈ړ
// s2 - SΏە̂Q̈ړ
// index - S̊Jns
    public function axis(p1:Position,p2:Position,s1:Vector3D,
      	      	      	 s2:Vector3D,index:int):void{
      var rot1:DefaultMatrix=p1.p.rotateMatrix();
      var rot2:DefaultMatrix=p2.p.rotateMatrix();
      var stl1:DefaultMatrix=Position.tildev(s1);
      var stl2:DefaultMatrix=Position.tildev(s2);
      var wtl1:DefaultMatrix=Position.tildev(p1.w);
      var wtl2:DefaultMatrix=Position.tildev(p2.w);
      var rotstl1:DefaultMatrix=mul2(rot1,stl1);
      var rotstl2:DefaultMatrix=mul2(rot2,stl2);
      var a12:DefaultMatrix=mul2(rot1.transposition(),rot2);
      var a21:DefaultMatrix=mul2(rot2.transposition(),rot1);

      var cth:Vector.<DefaultMatrix>=Vector.<DefaultMatrix>
      	([mul4(rotstl2,rot2.transposition(),rot1,stl1),
      	  mul(-1.0,mul3(rotstl1,rot1.transposition(),rotstl2))]);
      var a1:DefaultMatrix=add2(mul2(tilde(mulv(wtl2,s2)),a21),
      	      	      	      	mul3(stl2,a21,wtl1));
      a1=mul(-1.0,mul3(rot2,a1,stl1));
      var a2:DefaultMatrix=add2(mul2(tilde(mulv(wtl1,s1)),a12),
      	      	      	      	mul3(stl1,a12,wtl2));
      a2=mul3(rot1,a1,stl2);
      var gam:Vector.<Number>=addv2(mulv(a1,p1.w),mulv(a2,p2.w));
      var v1:Vector.<Number>=addv2(mulv(cth[0],p1.w),mulv(cth[1],p2.w));
      var v2:Vector.<Number>=mulv2(rotstl1,a12,s2);
      for(var i:int=0;i<3;i++){
      	gam[i]-=2.0*alpha*v1[i]+beta*beta*v2[i];
      }

      var cl:Vector.<int>=compList(mulv(rot1,s1));
      for(i=0;i<2;i++){
      	for(var j:int=0;j<3;j++){
      	  matrix[0].set(index+i,j+3,cth[0].get(cl[i],j));
      	  matrix[1].set(index+i,j+3,cth[1].get(cl[i],j));
      	}
      	vector[index+i]=gam[cl[i]];
      }
    }

//--------------------------------------------------------------------//
// ΈʒuS}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
// s - SΏە̂P̈ړ
// index - S̊Jns
    public function direction(p1:Position,p2:Position,s:Vector3D,
      	      	      	      index:int):void{
      var rot1:DefaultMatrix=p1.p.rotateMatrix();
      var rot2:DefaultMatrix=p2.p.rotateMatrix();
      var stl:DefaultMatrix=Position.tildev(s);
      var rtl1:DefaultMatrix=Position.tildep(r1);
      var rtl2:DefaultMatrix=Position.tildep(r2);
      var wtl1:DefaultMatrix=Position.tildev(p1.w);
      var wtl2:DefaultMatrix=Position.tildev(p2.w);
      var rotstl:DefaultMatrix=mul2(rot1,stl);
      var rtr:DefaultMatrix=mul2(rotstl,rot1.transposition());

      var d12:Vector.<Number>=p2.vector(r2);
      var d11:Vector.<Number>=p1.vector(r1);
      for(var i:int=0;i<3;i++){
      	d12[i]-=d11[i];
      }
      var cr:Vector.<DefaultMatrix>=Vector.<DefaultMatrix>
      	([mul(-1.0,rtr.copy()),rtr]);
      var cth:Vector.<DefaultMatrix>=Vector.<DefaultMatrix>
      	([add2(mul3(rtr,rot1,rtl1),mul2(tilde(d12),rotstl)),
      	  mul(-1.0,mul3(rtr,rot2,rtl2))]);
      var a2:DefaultMatrix=mul2(rot1,wtl1);
      var a1:DefaultMatrix=mul(2.0,add2(Position.tildev(p1.v),
      	      	      	       mul(-1.0,Position.tildev(p2.v))));
      var gam:Vector.<Number>=mulv2(a1,rotstl,p1.w);
      var v1:Vector.<Number>=mulp2(rot2,wtl2,r2);
      var v12:Vector.<Number>=mulp(a2,r1);
      for(i=0;i<3;i++){
      	v1[i]-=v12[i];
      }
      a1=mul(-1.0,add3(mul3(a2,stl,rtl1),mul2(tilde(v1),rotstl),
      	      	       mul3(tilde(d12),a2,stl)));
      a2=mul2(rot1.transposition(),rot2);
      a2=mul2(add2(mul3(rot1,tilde(mulv(wtl1,s)),a2),
      	       mul3(rtr,rot2,wtl2)),rtl2);
      v12=addv2(mulv(a1,p1.w),mulv(a2,p2.w));
      v1=addv4(mulv(cr[0],p1.v),mulv(cr[1],p2.v),
      	      	      	    mulv(cth[0],p1.w),mulv(cth[1],p2.w));
      var v2:Vector.<Number>=mulvn(rtr,d12);
      for(i=0;i<3;i++){
      	gam[i]+=v12[i];
      	gam[i]-=2.0*alpha*v1[i]+beta*beta*v2[i];
      }

      var cl:Vector.<int>=compList(mulv(rot1,s));
      for(i=0;i<2;i++){
      	for(var j:int=0;j<3;j++){
      	  matrix[0].set(index+i,j,cr[0].get(cl[i],j));
      	  matrix[0].set(index+i,j+3,cth[0].get(cl[i],j));
      	  matrix[1].set(index+i,j,cr[1].get(cl[i],j));
      	  matrix[1].set(index+i,j+3,cth[1].get(cl[i],j));
      	}
      	vector[index+i]=gam[cl[i]];
      }
    }

//--------------------------------------------------------------------//
// ]S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
// b1x - SΏە̂P̈ړ
// b2y - SΏە̂Q̈ړ
// index - S̊Jns
    public function rotate(p1:Position,p2:Position,b1x:Vector3D,
      	      	      	   b2y:Vector3D,index:int):void{
      var rot1:DefaultMatrix=p1.p.rotateMatrix();
      var rot2:DefaultMatrix=p2.p.rotateMatrix();
      var wtl1:DefaultMatrix=Position.tildev(p1.w);
      var wtl2:DefaultMatrix=Position.tildev(p2.w);
      var a12:DefaultMatrix=mul2(rot1.transposition(),rot2);
      var a21:DefaultMatrix=mul2(rot2.transposition(),rot1);

      var cth:Vector.<DefaultMatrix>=Vector.<DefaultMatrix>
      	([new DefaultMatrix(1,3),new DefaultMatrix(1,3)]);
      cth[0].set(0,0,-b2y.x);
      cth[0].set(0,1,-b2y.y);
      cth[0].set(0,2,-b2y.z);
      cth[0]=mul3(cth[0],a21,Position.tildev(b1x));
      cth[1].set(0,0,-b1x.x);
      cth[1].set(0,1,-b1x.y);
      cth[1].set(0,2,-b1x.z);
      cth[1]=mul3(cth[1],a12,Position.tildev(b2y));
      var a1:DefaultMatrix=add2(mul3(a21,wtl1,wtl1),
      	      	      	      	mul3(wtl2,wtl2,a21));
      var a2:DefaultMatrix=mul3(Position.tildev(b2y),a21,
      	      	      	      	Position.tildev(b1x));
      var v1:Vector.<Number>=mulv(a1,b1x);
      var gam1:Number=b2y.x*v1[0]+b2y.y*v1[1]+b2y.z*v1[2];
      v1=mulv(a2,p1.w);
      var gam2:Number=p2.w.x*v1[0]+p2.w.y*v1[1]+p2.w.z*v1[2];
      v1=addv2(mulv(cth[0],p1.w),mulv(cth[1],p2.w));
      var gam3:Number=v1[0];
      v1=mulv(a12,b2y);
      var gam4:Number=b1x.x*v1[0]+b1x.y*v1[1]+b1x.z*v1[2];
      var gam:Number=-gam1+2.0*gam2-2.0*alpha*gam3-beta*beta*gam4;
      for(var j:int=0;j<3;j++){
      	matrix[0].set(index,j+3,cth[0].get(0,j));
      	matrix[1].set(index,j+3,cth[1].get(0,j));
      }
      vector[index]=gam;
    }
  }
}
