package figure{

//--------------------------------------------------------------------//
// WsNX
  public class DefaultMatrix{

// s̐
    public var rowCount:int;

// ̐
    public var columnCount:int;

// i[z
    public var data:Array;

// ̐Βl̍ől
    public var dataMax:Number;

//--------------------------------------------------------------------//
    public function DefaultMatrix(rowCount:int,columnCount:int){
      this.rowCount=rowCount;
      this.columnCount=columnCount;
      data=new Array();
      for(var i:int=0;i<rowCount;i++){
      	data[i]=new Vector.<Number>(columnCount,true);
      	for(var j:int=0;j<columnCount;j++){
      	  data[i][j]=0.0;
      	}
      }
      dataMax=0.0;
    }

//--------------------------------------------------------------------//
// Ԃ
// row - s
// column - 
    public function get(row:int,column:int):Number{
      return data[row][column];
    }

//--------------------------------------------------------------------//
// ɒlݒ肷
// row - s
// column - 
// value - ݒ肷l
    public function set(row:int,column:int,value:Number):void{
      data[row][column]=value;
      dataMax=Math.max(dataMax,Math.abs(value));
    }

//--------------------------------------------------------------------//
// ɒl
// row - s
// column - 
// value - ݒ肷l
    public function add(row:int,column:int,value:Number):void{
      data[row][column]+=value;
      dataMax=Math.max(dataMax,Math.abs(value));
    }

//--------------------------------------------------------------------//
// s
// m - s
    public function addMatrix(m:DefaultMatrix):void{
      if((rowCount!=m.rowCount) || (columnCount!=m.columnCount)){
      	return;
      }
      for(var i:int=0;i<rowCount;i++){
      	for(var j:int=0;j<columnCount;j++){
      	  data[i][j]+=m.get(i,j);
      	}
      }
    }

//--------------------------------------------------------------------//
// XJ[|
// value - |XJ[l
    public function mul(value:Number):void{
      for(var i:int=0;i<rowCount;i++){
      	for(var j:int=0;j<columnCount;j++){
      	  data[i][j]*=value;
      	}
      }
      dataMax*=Math.abs(value);
    }

//--------------------------------------------------------------------//
// xNgƂ̐ςvZĕԂ
// p - E|xNg
    public function mulVector(p:Vector.<Number>):Vector.<Number>{
      var q:Vector.<Number>=new Vector.<Number>(rowCount,true);
      for(var i:int=0;i<rowCount;i++){
      	q[i]=0.0;
      	for(var j:int=0;j<columnCount;j++){
      	  q[i]+=data[i][j]*p[j];
      	}
      }
      return q;
    }

//--------------------------------------------------------------------//
// s̐ςvZĕԂ
// left - ̍s
// right - E̍s
    public static function mulMatrix(left:DefaultMatrix,
      	      	      	      	     right:DefaultMatrix):DefaultMatrix{
      if(left.columnCount!=right.rowCount) return null;
      var matrix:DefaultMatrix=new DefaultMatrix(left.rowCount,
      	      	      	      	      	      	 right.columnCount);
      for(var i:int=0;i<left.rowCount;i++){
      	for(var j:int=0;j<right.columnCount;j++){
      	  var sum:Number=0.0;
      	  for(var k:int=0;k<left.columnCount;k++){
      	    sum+=left.get(i,k)*right.get(k,j);
      	  }
      	  matrix.set(i,j,sum);
      	}
      }
      return matrix;
    }

//--------------------------------------------------------------------//
// s
// (̐Βl̍őlĐݒ肷)
    public function init():void{
      dataMax=0.0;
      for(var i:int=0;i<rowCount;i++){
      	for(var j:int=0;j<columnCount;j++){
      	  dataMax=Math.max(dataMax,Math.abs(data[i][j]));
      	}
      }
    }

//--------------------------------------------------------------------//
// ]usԂ
    public function transposition():DefaultMatrix{
      var m:DefaultMatrix=new DefaultMatrix(columnCount,rowCount);
      for(var i:int=0;i<rowCount;i++){
      	for(var j:int=0;j<columnCount;j++){
      	  m.set(j,i,data[i][j]);
      	}
      }
      return m;
    }

//--------------------------------------------------------------------//
// s񂪑Ώ̂ǂ𔻕ʂ
    public function isSymmetry():Boolean{
      if(rowCount!=columnCount) return false;
      for(var i:int=0;i<rowCount-1;i++){
      	for(var j:int=i+1;j<columnCount;j++){
      	  if(data[i][j]!=data[j][i]) return false;
      	}
      }
      return true;
    }

//--------------------------------------------------------------------//
// ̍s̃Rs[쐬
    public function copy():DefaultMatrix{
      var m:DefaultMatrix=new DefaultMatrix(rowCount,columnCount);
      for(var i:int=0;i<rowCount;i++){
      	m.data[i]=new Vector.<Number>(columnCount,true);
      	for(var j:int=0;j<columnCount;j++){
      	  m.data[i][j]=data[i][j];
      	}
      }
      m.dataMax=dataMax;
      return m;
    }

  }
}
